#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <linux/soundcard.h>
#include <math.h>
#include <SDL.h>
#include <SDL_image.h>
#include <SDL_mixer.h>
#include <SDL_gfxPrimitives.h>
#include <SDL_Framerate.h>

#define SCREEN_WIDTH 320
#define SCREEN_HEIGHT 240
#define SCREEN_DEPTH 16
enum MAP_KEY {
	VK_UP         , // 0
	VK_UP_LEFT    , // 1
	VK_LEFT       , // 2
	VK_DOWN_LEFT  , // 3
	VK_DOWN       , // 4
	VK_DOWN_RIGHT , // 5
	VK_RIGHT      , // 6
	VK_UP_RIGHT   , // 7
	VK_START      , // 8
	VK_SELECT     , // 9
	VK_FL         , // 10
	VK_FR         , // 11
	VK_FA         , // 12
	VK_FB         , // 13
	VK_FX         , // 14
	VK_FY         , // 15
	VK_VOL_UP     , // 16
	VK_VOL_DOWN   , // 17
	VK_TAT          // 18
};

void gp2x_set_volume(int leftVolume, int rightVolume);
int DrawImage( SDL_Surface *surface, SDL_Surface *image, int x_pos, int y_pos,int alpha, SDL_Rect *clip);
void DrawPlayField();
void confirm_exit();
void DrawPlayer();
void DrawEnemy();
void flushevents();
void outoffuel();
void gameover();
void fuelmine();
void tankmine();
void hypermine(SDL_Surface *screen,bool warpstate);
void unknownmine();
void destructomine(bool byenemy=false);
void pointmine();
void supermine();
void mapmine();
void DrawVolumeDisplay();
void GameInitialize();
void tunnelize(SDL_Surface *surface,int step);
int fastPixelColorNolock (SDL_Surface *dst, Sint16 x, Sint16 y, Uint32 color);
Uint32 getpixel(SDL_Surface *surface, int x, int y);
void progressbar(int x1,int y1,int x2,int y2,int r,int g,int b,int a,int max,int val);
void youwin();
void waitforpress();
void screenshot();

bool warped=false;
bool gamestart=true;
bool idle=false;
bool trymove=false;
bool moving=false;
bool freefuel=false;
bool done=0;

bool emoving=false;
bool etrymove=false;
int exoffset=0;
int eyoffset=0;
int ex=0;
int ey=0;
int estate=0;
int volume=75;
int volume_display_timer=0;

int thousands=0;
int enginesound=2;
int facing=0;
int wantsfacing=0;
int scrollxoffset=0;
int scrollyoffset=0;
int fuellevel=50;
int extratanks=2;
int x=59;
int y=42;
int superminecount=0;
int ethreattimer=0;

char * buffer;
char item;

long score=0;

SDL_Surface *screen;
SDL_Surface *temp;

SDL_Surface *hud;
SDL_Surface *hudside;

SDL_Surface *numbers;
SDL_Rect digitoffset;
SDL_Surface *lifemarker;
SDL_Surface *fuelpointer;

SDL_Surface *background;
SDL_Surface *sky;
SDL_Joystick *joy = NULL;

SDL_Surface *gameoverimg;
SDL_Surface *youwinimg;

SDL_Surface *nw;
SDL_Surface *sw;
SDL_Surface *ne;
SDL_Surface *se;

SDL_Surface *n_int;
SDL_Surface *s_int;
SDL_Surface *w_int;
SDL_Surface *e_int;
SDL_Surface *t_int;

SDL_Surface *n_end;
SDL_Surface *s_end;
SDL_Surface *w_end;
SDL_Surface *e_end;

SDL_Surface *h_wall;
SDL_Surface *v_wall;

SDL_Surface *fuel;
SDL_Surface *tank;
SDL_Surface *hyper;
SDL_Surface *unknown;
SDL_Surface *destructo;
SDL_Surface *point;
SDL_Surface *super;
SDL_Surface *map;

SDL_Surface *playern;
SDL_Surface *playere;
SDL_Surface *players;
SDL_Surface *playerw;
Mix_Chunk* warpin;
Mix_Chunk* warpout;
Mix_Chunk* moving_sound;
Mix_Chunk* idle_sound;
Mix_Chunk* death_sound;
Mix_Chunk* startmove_sound;
Mix_Chunk* stopmove_sound;
Mix_Chunk* fuelsound;
Mix_Chunk* extratanksound;
Mix_Chunk* pointminesound;
Mix_Chunk* unknownminesound;
Mix_Chunk* outoffuelsound;
Mix_Chunk* mapminesound;
Mix_Chunk* superminesound;
Mix_Chunk* threatsound;
FPSmanager manager;

int main(int argc, char *argv[]) {
	gp2x_set_volume(volume,volume);

	FILE *errfile = fopen("/mnt/ext/error.txt","w");
	
	/* Initialize SDL */
	if (SDL_Init (SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_JOYSTICK) < 0) {
		fprintf (errfile, "Couldn't initialize SDL: %s\n", SDL_GetError ());
		exit (1);
	}
     
     /* Initialize the screen / window */
     screen = SDL_SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_DEPTH, SDL_HWSURFACE|SDL_DOUBLEBUF);
   	SDL_ShowCursor(SDL_DISABLE);
 
	if (SDL_NumJoysticks() > 0) {
		joy = SDL_JoystickOpen(0);
		if(!joy) {
			fprintf (errfile, "Couldn't open joystick 0: %s\n", SDL_GetError ());
		}
	}

	SDL_initFramerate(&manager);

    temp = IMG_Load("./img/title.png");
	SDL_Surface *title=SDL_DisplayFormatAlpha(temp);
	DrawImage(screen,title,0,0,255,NULL);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
	DrawImage(screen,title,0,0,255,NULL);

	//boxRGB(screen, 0,230,(i*6),240, 255, 0, 0);

    if (Mix_OpenAudio(22050, AUDIO_S16, 2, 512)==-1)
    {
		printf("Mix_OpenAudio: %s\n", Mix_GetError());
        return 1;
    }
	Mix_ReserveChannels(4);

	warpin = Mix_LoadWAV("./Audio/warpin.ogg");
	progressbar(0,230,320,240,255,0,0,255,51,1);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
    warpout = Mix_LoadWAV("./Audio/warpout.ogg");
	progressbar(0,230,320,240,255,0,0,255,51,2);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
    moving_sound = Mix_LoadWAV("./Audio/moving.ogg");
	progressbar(0,230,320,240,255,0,0,255,51,3);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
    idle_sound = Mix_LoadWAV("./Audio/idle.ogg");
	progressbar(0,230,320,240,255,0,0,255,51,4);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
    death_sound = Mix_LoadWAV("./Audio/death.ogg");
	progressbar(0,230,320,240,255,0,0,255,51,5);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
    startmove_sound = Mix_LoadWAV("./Audio/accel.ogg");
	progressbar(0,230,320,240,255,0,0,255,51,6);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
    stopmove_sound = Mix_LoadWAV("./Audio/deccel.ogg");
	progressbar(0,230,320,240,255,0,0,255,51,7);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
    fuelsound = Mix_LoadWAV("./Audio/fuelsound.ogg");
	progressbar(0,230,320,240,255,0,0,255,51,8);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
    extratanksound = Mix_LoadWAV("./Audio/extratank.ogg");
	progressbar(0,230,320,240,255,0,0,255,51,9);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
    pointminesound = Mix_LoadWAV("./Audio/500points.ogg");
	progressbar(0,230,320,240,255,0,0,255,51,10);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
    unknownminesound = Mix_LoadWAV("./Audio/unknownmine.ogg");
	progressbar(0,230,320,240,255,0,0,255,51,11);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
    outoffuelsound = Mix_LoadWAV("./Audio/outoffuel.ogg");
	progressbar(0,230,320,240,255,0,0,255,51,12);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
    mapminesound= Mix_LoadWAV("./Audio/mapminesound.ogg");
	progressbar(0,230,320,240,255,0,0,255,51,13);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
    superminesound= Mix_LoadWAV("./Audio/superminesound.ogg");
	progressbar(0,230,320,240,255,0,0,255,51,14);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
	threatsound= Mix_LoadWAV("./Audio/threat.ogg");
	progressbar(0,230,320,240,255,0,0,255,51,15);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
	
	/* Load test.bmp */
    temp = IMG_Load("./img/floor.png");
	background=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,16);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	temp = IMG_Load("./img/sky.png");
	sky=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,17);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	temp = IMG_Load("./img/gameover.png");
	gameoverimg=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,18);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	temp = IMG_Load("./img/youwin.png");
	youwinimg=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,19);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	temp = IMG_Load("./img/hud.png");
	hud=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,20);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
	
	temp = IMG_Load("./img/hudside.png");
	hudside=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,21);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
	
	temp = IMG_Load("./img/numbers.png");
	numbers=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,22);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	temp = IMG_Load("./img/lifemarker.png");
	lifemarker=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,23);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	temp = IMG_Load("./img/fuelpointer.png");
	fuelpointer=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,24);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	temp = IMG_Load("./img/nw.png");//1
	nw = SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,25);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/ne.png");//2
	sw = SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,26);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/sw.png");//3
	ne = SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,27);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp= IMG_Load("./img/se.png");//4
	se=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,28);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/n_int.png");//5
	n_int =SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,29);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/s_int.png");//6
	s_int=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,30);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/e_int.png");//7
	e_int=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,31);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/w_int.png");//8
	w_int=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,32);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/t_int.png");//9
	t_int =SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,33);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/n_end.png");//10
	n_end=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,34);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/s_end.png");//11
	s_end=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,35);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/e_end.png");//12
	e_end=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,36);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/w_end.png");//13
	w_end=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,37);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/h_wall.png");//14
	h_wall=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,38);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/v_wall.png");//15
	v_wall=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,39);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/fuel.png");//1
	fuel=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,40);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/extratank.png");//2
	tank=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,41);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	temp = IMG_Load("./img/hyper.png");//3
	hyper=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,42);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	temp = IMG_Load("./img/unknown.png");//4
	unknown=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,43);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	temp = IMG_Load("./img/destructo.png");//5
	destructo=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,44);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	temp = IMG_Load("./img/point.png");//6
	point=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,45);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	temp = IMG_Load("./img/super.png");//7
	super=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,46);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	temp = IMG_Load("./img/map.png");//8
	map=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,47);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp= IMG_Load("./img/playern.png");//8
	playern=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,48);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	temp = IMG_Load("./img/playere.png");//8
	playere=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,49);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp= IMG_Load("./img/players.png");//8
	players=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,50);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

    temp = IMG_Load("./img/playerw.png");//8
	playerw=SDL_DisplayFormatAlpha(temp);
	progressbar(0,230,320,240,255,0,0,255,51,51);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	//SDL_initFramerate(&fpsman);
	flushevents();
	srand(time(NULL));
	hypermine(screen,0);

	GameInitialize();

	ex=rand()%120;
	ey=rand()%85;

	while(!done){
		//user_input();
		SDL_Event event;

		/* Check for events */
		//if (!slidecycle && !scrollcycle){
		while (SDL_PollEvent (&event)){
			switch (event.type){
				case SDL_KEYDOWN:
                case SDL_JOYBUTTONDOWN:
					
					/* Right now I have Start end the program for debug purposes */
					if (( (event.key.keysym.sym == SDLK_c) && (event.key.keysym.mod & (KMOD_LCTRL | KMOD_RCTRL)))) {
						done = 1;
					}
					if (( event.key.keysym.sym == SDLK_s )||( event.jbutton.button == VK_FA )) {
                    }     
					if (( event.key.keysym.sym == SDLK_d )||( event.jbutton.button == VK_FY )) {
					}
					if (( event.key.keysym.sym == SDLK_c )||( event.jbutton.button == VK_FB )) {
                    }     
					if (( event.key.keysym.sym == SDLK_x )||( event.jbutton.button == VK_FX )) {
						trymove=true;
						if (enginesound==0) Mix_FadeOutChannel(2,25);
						enginesound=1;
						Mix_PlayChannel(3, startmove_sound, 0);
					}
					if (( event.key.keysym.sym == SDLK_RIGHT )||( event.jbutton.button == VK_RIGHT )) {
						if (!moving){
							facing=1;wantsfacing=1;
						} else {
							wantsfacing=1;
						}
					}     
					if (( event.key.keysym.sym == SDLK_LEFT )||( event.jbutton.button == VK_LEFT )) {
						if (!moving){
							facing=3;wantsfacing=3;
						} else {
							wantsfacing=3;
						}

					}     
					if (( event.key.keysym.sym == SDLK_UP )||( event.jbutton.button == VK_UP )) {
						if (!moving){
							facing=0;wantsfacing=0;
						} else {
							wantsfacing=0;
						}
                    }     
                    if (( event.key.keysym.sym == SDLK_DOWN )||( event.jbutton.button == VK_DOWN )) {
						if (!moving){
							facing=2;wantsfacing=2;
						} else {
							wantsfacing=2;
						}
					}
                    if (( event.key.keysym.sym == SDLK_f )||( event.jbutton.button == VK_FR )) {
						screenshot();
					}
                    if (( event.key.keysym.sym == SDLK_a )||( event.jbutton.button == VK_FL )) {
					}
                    if (( event.key.keysym.sym == SDLK_BACKSPACE )||( event.jbutton.button == VK_SELECT )) {
					}
                    if (( event.key.keysym.sym == SDLK_BACKSPACE )||( event.jbutton.button == VK_START )) {
						confirm_exit();
					}
                    if (( event.key.keysym.sym == SDLK_BACKSPACE )||( event.jbutton.button == VK_VOL_UP )) {
						volume=volume+5;
						if (volume>255){volume=255;}
						gp2x_set_volume(volume,volume);
						volume_display_timer=SDL_GetTicks();
					}
                    if (( event.key.keysym.sym == SDLK_BACKSPACE )||( event.jbutton.button == VK_VOL_DOWN )) {
						volume=volume-5;
						if (volume<0){volume=0;}
						gp2x_set_volume(volume,volume);
						volume_display_timer=SDL_GetTicks();
					}
                    if (( event.key.keysym.sym == SDLK_HOME )||( event.jbutton.button == VK_TAT )) {
					}
					//buttonpressed=true;
					//buttontimer=SDL_GetTicks();
					break;
				case SDL_KEYUP:
				case SDL_JOYBUTTONUP:     
					if (( event.key.keysym.sym == SDLK_x )||( event.jbutton.button == VK_FX )) {
						trymove=false; idle=true;
						if (enginesound==1) Mix_FadeOutChannel(2,25);
						enginesound=0;
						Mix_PlayChannel(3, stopmove_sound, 0);
					}
					if (( event.key.keysym.sym == SDLK_RIGHT )||( event.jbutton.button == VK_RIGHT )) {
						wantsfacing=facing;
					}     
					if (( event.key.keysym.sym == SDLK_LEFT )||( event.jbutton.button == VK_LEFT )) {
						wantsfacing=facing;
					}     
					if (( event.key.keysym.sym == SDLK_UP )||( event.jbutton.button == VK_UP )) {
						wantsfacing=facing;
                    }     
                    if (( event.key.keysym.sym == SDLK_DOWN )||( event.jbutton.button == VK_DOWN )) {
						wantsfacing=facing;
					}

				//buttonpressed=false;					
					//buttontimerresolution=500;
				    break;
				case SDL_QUIT:
					done = 1;
					break;
				default:
					//buttonpressed=false;					
					//buttontimerresolution=500;
					break;
			}
		}

		if (scrollxoffset!=0) scrollxoffset=scrollxoffset>0?scrollxoffset-3:scrollxoffset+3;
		if (scrollyoffset!=0) scrollyoffset=scrollyoffset>0?scrollyoffset-3:scrollyoffset+3;

		if (exoffset!=0) exoffset=exoffset>0?exoffset-6:exoffset+6;
		if (eyoffset!=0) eyoffset=eyoffset>0?eyoffset-6:eyoffset+6;
		if (exoffset==0 && eyoffset==0) {
			if (emoving){
				emoving=false;
			}
			//etrymove=true;
			//fprintf (stderr,"X,Y: %d,%d EX,EY: %d,%d Delta: %d,%d\n",x,y,ex,ey,ex-x,ey-y);
			long offset=ex+(ey*121);
			buffer[offset]=buffer[offset]-(buffer[offset]&240);
		}

		if (trymove && !moving && !warped){
			idle=true;
			//fprintf (stderr,"EX: %d EY: %d\n Distance to Enemy: %f\n",ex,ey, sqrt(pow(x-ex,2)+pow(y-ey,2)));
			long offset=x+(y*121);
			char nwall=buffer[offset] & 1;
			char wwall=buffer[offset] & 2;
			char swall=buffer[offset+121] & 1;
			char ewall=buffer[offset+1] & 2;
			if (facing==0){
				int ty=y-1;
				if(nwall==0 && !((ty==ey) && (x==ex))) {
					y--;
					scrollyoffset=-24;
					if (enginesound==0) Mix_FadeOutChannel(2,25);
					moving=true;
					idle=false;
				}
			}
			if (facing==2){
				int ty=y+1;
				if(swall==0 && !((ty==ey) && (x==ex))) {
					y++;
					scrollyoffset=24;
					if (enginesound==0) Mix_FadeOutChannel(2,25);
					moving=true;
					idle=false;
				}
			}
			if (facing==3){
				int tx=x-1;
				if(wwall==0 && !((tx==ex) && (y==ey))) {
					x--;
					scrollxoffset=-24;
					if (enginesound==0) Mix_FadeOutChannel(2,25);
					moving=true;
					idle=false;
				}
			}
			if (facing==1){
				int tx=x+1;
				if(ewall==0 && !((tx==ex) && (y==ey))) {
					x++;
					scrollxoffset=24;
					if (enginesound==0) Mix_FadeOutChannel(2,25);
					moving=true;
					idle=false;
				}
			}
		}

		if (moving && Mix_Playing(2)!=1){
			enginesound=1;
			Mix_PlayChannel(2, moving_sound, 0);
		}
		if (idle && Mix_Playing(2)!=1){
			enginesound=0;
			Mix_PlayChannel(2, idle_sound, 0);
		}

		if (!moving){Mix_HaltChannel(0);}

		if (scrollxoffset==0 && scrollyoffset==0 && (moving || warped)) {
			if (!trymove){Mix_FadeOutChannel(2,25);}
			moving=false;
			warped=false;
			facing=wantsfacing;
			fuellevel--;
			score++;
			long offset=x+(y*121);
			item=(buffer[offset]&240)/16;
			buffer[offset]=buffer[offset]-(buffer[offset]&240);
		} else { 
			item=0;
		}

		if (ex>x-7 && ex<x+8 && ey>y-5 && ey<y+6 && SDL_GetTicks()-ethreattimer>30000){
			Mix_PlayChannel(4, threatsound, 0);
			ethreattimer=SDL_GetTicks();
		}

		if (etrymove && !emoving){
			etrymove=false;
			long offset=ex+(ey*121);
			char itemn=(buffer[offset-121]&240)/16;
			char iteme=(buffer[offset+1]&240)/16;
			char items=(buffer[offset+121]&240)/16;
			char itemw=(buffer[offset-1]&240)/16;

			if (itemn==1){
				ey--;
				//eyoffset=-24;
				emoving=true;
			}
			if (iteme==1 && !emoving){
				ex++;
				//exoffset=24;
				emoving=true;
			}
			if (items==1 && !emoving){
				ey++;
				//eyoffset=24;
				emoving=true;
			}
			if (itemw==1 && !emoving){
				ex--;
				//exoffset=-24;
				emoving=true;
			}
			//buffer[offset]=buffer[offset]-(buffer[offset]&240);
			
			if (!emoving){
				if (x<ex){
					ex--;
					//exoffset=24;
					emoving=true;
				}
				if (x>ex && !emoving){
					ex++;
					//exoffset=-24;
					emoving=true;
				}
				if (y<ey && !emoving){
					ey--;
					//eyoffset=24;
					emoving=true;
				}
				if (y>ey && !emoving){
					ey++;
					//eyoffset=-24;
					emoving=true;
				}
			}
		}

		if (!moving){
			if (ex==x && ey==y){
				destructomine(true);
				hypermine(screen,false);
				score=score-50;
				scrollxoffset=0;
				scrollyoffset=0;
			}
			estate++;
			if (estate>2){
				estate=0;
				etrymove=true;
				exoffset=0; eyoffset=0;
			}
			if (sqrt(pow(x-ex,2)+pow(y-ey,2))<4){
				etrymove=true;
				exoffset=0; eyoffset=0;
			}
		}

		switch (item){
			case 1:
				fuelmine();
				etrymove=true;
			break;
			case 2:
				tankmine();
				etrymove=true;
			break;
			case 3:
				hypermine(screen,false);
				etrymove=true;
			break;
			case 4:
				destructomine();
				etrymove=true;
			break;
			case 5:
				unknownmine();
				etrymove=true;
			break;
			case 6:
				pointmine();
				etrymove=true;
			break;
			case 7:
				supermine();
				etrymove=true;
			break;
			case 8:
				mapmine();
				etrymove=true;
			break;
		}

		if (fuellevel<0){
			outoffuel();
			etrymove=true;
		}
		if (extratanks==-1){
			gameover();
		}
		if (freefuel){
			fuelmine();
			score=score-100;
			freefuel=false;
		}

		if (superminecount==4){
			youwin();
		}
		if (!done){
			DrawPlayField();

			DrawPlayer();
			DrawEnemy();
			if (warped || gamestart){
				hypermine(screen,true);
				etrymove=true;
			}
	
			if (SDL_GetTicks()-volume_display_timer<2000){
				DrawVolumeDisplay();
			}

			SDL_Flip(screen);
			SDL_framerateDelay(&manager);
		}
		gamestart=false;
	}
	return 0;
	free (buffer);
}

int DrawImage( SDL_Surface *surface, SDL_Surface *image, int x_pos, int y_pos,int alpha, SDL_Rect *clip){
	if (alpha<255){
		SDL_SetAlpha( image, SDL_SRCALPHA | SDL_RLEACCEL, alpha );
	}
    SDL_Rect rcDest = { x_pos, y_pos, 0, 0 };
	    SDL_BlitSurface ( image, clip, surface, &rcDest );
    return 0;
}

void flushevents(){
	SDL_Event ev;
	while (SDL_PollEvent(&ev)) {};
	return;
}

void outoffuel(){
	Mix_FadeOutChannel(2,25);
	Mix_PlayChannel(1, outoffuelsound, 0);
	while (Mix_Playing(1));
	destructomine();
}

void gameover(){
	SDL_Surface *temp1;
	temp1 = SDL_DisplayFormatAlpha(screen);
	for (int i=1;i<=255 ;i=i+5 ){
		DrawImage(screen,temp1,0,0,255,NULL);
		boxRGBA(screen,0,0,320,240,0,0,0,i);
		SDL_Rect wipe = {0,0,(Uint16)(gameoverimg->w*(float)((float)i/255)),gameoverimg->h};
		DrawImage(screen,gameoverimg,160-gameoverimg->w/2,120-gameoverimg->h/2,255,&wipe);
		SDL_Flip(screen);
		SDL_framerateDelay(&manager);
	}
	waitforpress();
	GameInitialize();
}

void fuelmine(){
	if (fuellevel<50){
		Mix_FadeOutChannel(2,25);
		for (int i=0; i<25 ;  i++  ){
			fuellevel++;
			DrawPlayField();
			DrawPlayer();
			Mix_PlayChannel(1, fuelsound, 0);
			SDL_Delay((60-fuellevel)*2);
			SDL_Flip(screen);
			if (fuellevel==50) break;
		}
	}
	score=score+100;
}

void tankmine(){
	Mix_FadeOutChannel(2,25);
	Mix_PlayChannel(1, extratanksound, 0);
	extratanks++;
	DrawPlayField();
	DrawPlayer();
	SDL_Flip(screen);
	if (extratanks<=6){
		for (int i=0;i<3 ;i++ ){
			for (int j=0;j<3 ;j++ ){
				DrawPlayField();
				DrawPlayer();
				for (int k=0;k<=j ;k++ ){
					DrawImage( screen, lifemarker,9+extratanks*13, 216,255, NULL);
				}
				SDL_Flip(screen);
				SDL_framerateDelay(&manager);
			}
		}
	}
	while (Mix_Playing(1));
	score=score+150;
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
}

void hypermine(SDL_Surface *screen,bool warpstate){
	SDL_Surface *temp1;
	SDL_Surface *temp2;
	SDL_Surface *temp3;
	SDL_Surface *temp4;
	SDL_Surface *temp5;
	int nx=rand()%120;
	int ny=rand()%85;
	int n=(int)sqrt(pow(x-nx,2)+pow(y-ny,2));

	temp1 = SDL_DisplayFormatAlpha(screen);
	tunnelize (temp1,n/10);
	temp2 = SDL_DisplayFormatAlpha(temp1);
	tunnelize (temp2,n/10);
	temp3 = SDL_DisplayFormatAlpha(temp2);
	tunnelize (temp3,n/10);
	temp4 = SDL_DisplayFormatAlpha(temp3);
	tunnelize (temp4,n/10);
	temp5 = SDL_DisplayFormatAlpha(temp4);
	tunnelize (temp5,n/10);

	if (warpstate==false){
		x=nx;
		y=ny;
	   	Mix_FadeOutChannel(2,25);
		warped=true;
		Mix_PlayChannel(1, warpout, 0);
		
		DrawImage(screen,temp1,0,0,255,NULL);
		SDL_Flip(screen);
		SDL_framerateDelay(&manager);
		
		DrawImage(screen,temp2,0,0,255,NULL);
		SDL_Flip(screen);
		SDL_framerateDelay(&manager);
		
		DrawImage(screen,temp3,0,0,255,NULL);
		SDL_Flip(screen);
		SDL_framerateDelay(&manager);
		
		DrawImage(screen,temp4,0,0,255,NULL);
		SDL_Flip(screen);
		SDL_framerateDelay(&manager);
		
		DrawImage(screen,temp5,0,0,255,NULL);
		SDL_Flip(screen);
		SDL_framerateDelay(&manager);
		score=score+50;
	} else {
		Mix_PlayChannel(1, warpin, 0);
		
		DrawImage(screen,temp5,0,0,255,NULL);
		SDL_Flip(screen);
		SDL_framerateDelay(&manager);
		
		DrawImage(screen,temp4,0,0,255,NULL);
		SDL_Flip(screen);
		SDL_framerateDelay(&manager);
		
		DrawImage(screen,temp3,0,0,255,NULL);
		SDL_Flip(screen);
		SDL_framerateDelay(&manager);
		
		DrawImage(screen,temp2,0,0,255,NULL);
		SDL_Flip(screen);
		SDL_framerateDelay(&manager);

		DrawImage(screen,temp1,0,0,255,NULL);
		SDL_Flip(screen);
		SDL_framerateDelay(&manager);
	}
	SDL_FreeSurface(temp1);
	SDL_FreeSurface(temp2);
	SDL_FreeSurface(temp3);
	SDL_FreeSurface(temp4);
	SDL_FreeSurface(temp5);
}

void unknownmine(){
	Mix_FadeOutChannel(2,25);
	Mix_PlayChannel(1, unknownminesound, 0);
	int tick = 750;
	int itemx =0;
	while (Mix_Playing(1)){
	tick=(int)ceil(tick/1.5);
	itemx=rand()%1000;
		DrawPlayField();
		DrawPlayer();
		if (itemx<=250){
			DrawImage( screen, fuel, 158, 110,255, NULL);
			SDL_Flip(screen);
			SDL_Delay(tick);
		}
		if (itemx>250 && itemx<=350){
			DrawImage( screen, tank, 158, 110,255, NULL);
			SDL_Flip(screen);
			SDL_Delay(tick);
		}
		if (itemx>350 && itemx<=850){
			DrawImage( screen, hyper, 158, 110,255, NULL);
			SDL_Flip(screen);
			SDL_Delay(tick);
		}
		if (itemx>850 && itemx<=950){
			DrawImage( screen, destructo, 158, 110,255, NULL);
			SDL_Flip(screen);
			SDL_Delay(tick);
		}
		if (itemx>950 && itemx<=998){
			DrawImage( screen, point, 158, 110,255, NULL);
			SDL_Flip(screen);
			SDL_Delay(tick);
		}
		if (itemx==999){
			DrawImage( screen, super, 158, 110,255, NULL);
			SDL_Flip(screen);
			SDL_Delay(tick);
		}
	}
		if (itemx<=250){
			fuelmine();
		}
		if (itemx>250 && itemx<=350){
			tankmine();
		}
		if (itemx>350 && itemx<=850){
			hypermine(screen,false);
		}
		if (itemx>850 && itemx<=950){
			destructomine();
		}
		if (itemx>950 && itemx<=998){
			pointmine();
		}
		if (itemx==999){
			supermine();
		}
}

void destructomine(bool byenemy){
	Mix_FadeOutChannel(2,25);
	Mix_PlayChannel(1, death_sound, 0);
	extratanks--;
	fuellevel=50;
	boxRGBA(screen, 0, 0, 320,240, 255, 0, 0, 128);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
	DrawPlayField();
	SDL_Surface *temp;
	SDL_Surface *playertemp=NULL;
	temp = SDL_DisplayFormatAlpha(screen);
	//playertemp = SDL_DisplayFormatAlpha(screen);
	int basex=0;
	int basey=0;
	switch (facing){
	case 0:
		playertemp = SDL_DisplayFormatAlpha(playern);
		basex=156; basey=107;
		break;
	case 1:
		playertemp = SDL_DisplayFormatAlpha(playere);
		basex=158; basey=108;
		break;
	case 2:
		playertemp = SDL_DisplayFormatAlpha(players);
		basex=157; basey=109;
		break;
	case 3:
		playertemp = SDL_DisplayFormatAlpha(playerw);
		basex=155; basey=107;
		break;
	}
	int acc=1;
	for (int i=0;i<15;i++){
		acc=acc+i;
		DrawImage(screen,temp,0,0,255,NULL);
		DrawEnemy();
		SDL_Rect dbox;
		for (int bx=0;bx<24;bx=bx+4 ){
			for (int by=0;by<24;by=by+4 ){
				dbox = (SDL_Rect){bx,by,8,8};
				int accx=acc*(bx==0?-3:bx==4?-2:bx==8?-1:bx==12?1:bx==16?2:3);
				int accy=acc*(by==0?-3:by==4?-2:by==8?-1:by==12?1:by==16?2:3);
				DrawImage(screen,playertemp,basex + bx+accx , basey + by+accy ,255,&dbox);		
			}
		}
		SDL_Flip(screen);
		SDL_framerateDelay(&manager);
	}
	DrawPlayField();
	DrawEnemy();
	while (Mix_Playing(1));
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
	if (byenemy==false && extratanks>0){
		hypermine(screen,true);
	}
	SDL_FreeSurface(temp);
	SDL_FreeSurface(playertemp);
}
void pointmine(){
	Mix_FadeOutChannel(2,25);
	Mix_PlayChannel(4, pointminesound, 0);
	for (int i=0;i<20 ;i++ ){
		score=score+25;
		DrawPlayField();
		DrawPlayer();
		SDL_Flip(screen);
		SDL_framerateDelay(&manager);
	}
	SDL_Delay (500);
}
void supermine(){
	bool go =false;
	Mix_FadeOutChannel(2,25);
	Mix_PlayChannel(3, superminesound, 0);
	for (int i=1;i<=170;i++ ){
		DrawPlayField();
		if (i<=25){score++;} //(25*1) 25
		if (i<=120 && i>25){score=score+5;} //((120-25=95)*5)= 475 + 25 = 500
		if (i<=170 && i>120){score=score+10;} //(170-120=50)*10)= 500 + 500 = 1000
		if (freefuel){
			Mix_Pause(3);
			fuelmine();
			Mix_Resume(3);
			score=score-100;
			freefuel=false;
		}
		//if (superminecount && go){
		//	tunnelize (screen,i/5);
		//}
		go=!go;
		DrawPlayer();
		SDL_Flip(screen);
		SDL_framerateDelay(&manager);
	}
	while (Mix_Playing(3));
	superminecount++;
}

void mapmine(){
	boxRGBA(screen, 16, 0, 304,216, 0, 0, 0, 255);
	boxRGBA(screen, 9*15+24, 9*11+9, 9*15+26,9*11+10, 255, 0, 255, 255);
	int xpos=0;
	for (int xs=x-15;xs<x+16 ;xs++ ){
		int ypos=0;
		for (int ys=y-11;ys<y+12 ;ys++ ){
			long offset=x+(y*121);
			char item=0;
			char hwall=0;
			char vwall=0;
			if (xs>=0 && xs<=120 &&ys>=0 && ys<=85){
				offset=xs+(ys*121);
				hwall=buffer[offset] & 1;
				vwall=buffer[offset] & 2;
				item=(buffer[offset]&240)/16;
			}
			if (vwall) boxRGBA(screen, 9*xpos+21, 9*ypos+5, 9*xpos+22,9*ypos+13, 255, 255, 255, 255);
			if (hwall) boxRGBA(screen, 9*xpos+21, 9*ypos+5, 9*xpos+31,9*ypos+6, 255, 255, 255, 255);
			if (item) boxRGBA(screen, 9*xpos+24, 9*ypos+8, 9*xpos+26,9*ypos+10, 255, 0, 0, 255);
			ypos++;
		}
		xpos++;
	}
	SDL_Flip(screen);
	Mix_FadeOutChannel(2,25);
	Mix_PlayChannel(1, mapminesound, 0);
	while (Mix_Playing(1));
}

void tunnelize(SDL_Surface *surface,int step){
	SDL_LockSurface(surface);
	int w=304;
	int h=216;
	int xc=167;
	int yc=120;
		for (int x=16;x<=w ;x++ ){
			for (int y=0;y<=h ;y++ ){
				Uint32 p = getpixel(surface,x,y);
				Uint32 p2 = getpixel(surface,(int)(x<xc?x+step:x-step-1),(int)(y<yc?y+step:y-step-1));
				Uint8 r=0, g=0, b=0, a=0;
				Uint8 sr=0, sg=0, sb=0, sa=0;
				Uint8 fr=0, fg=0, fb=0, fa=0;

				SDL_GetRGBA  (p, surface->format, &r, &g, &b, &a);			
				SDL_GetRGBA  (p2, surface->format, &sr, &sg, &sb, &sa);			
				a=128;
				sa=128;
				if (a){
					fr=((r<<8) + (sr-r)*sa + sr) >> 8;
					fg=((g<<8) + (sg-g)*sa + sg) >> 8;
					fb=((b<<8) + (sb-b)*sa + sb) >> 8;
					fa=sa+a - ((sa*a)/255);
				} else {
					fr=(((sr-r)*(sa))>>8)+r;
					fg=(((sg-g)*(sa))>>8)+g;
					fb=(((sb-b)*(sa))>>8)+b;
					fa=sa+a - ((sa*a)/255);
				}

				//frintf(stderr,"Pixeldata: %X %X %X %X x:%d y:%d\n", r,g,b,a,x_pos+x-thisclip.x,y_pos+y-thisclip.y);
				//*(surface->pixels+ (y+y_pos) * image->pitch + (x+x_pos) * 32)=SDL_MapRGBA(surface->format,r,g,b,a);
				fastPixelColorNolock (surface,x,y,SDL_MapRGBA(surface->format,fr,fg,fb,fa));
			}
		}
	SDL_UnlockSurface(surface);
}

int fastPixelColorNolock (SDL_Surface *dst, Sint16 x, Sint16 y, Uint32 color)
{
  int bpp; 
  Uint8 *p; 
      
  /* Honor clipping setup at pixel level */
  if (1) {

    /* Get destination format */
    bpp = dst->format->BytesPerPixel;
    p=0;
	p = (Uint8 *)dst->pixels + y * dst->pitch + x * bpp;
    
	//fprintf (errfile,"sourcepixeldata: %x\n",(unsigned int)p);
	
	switch(bpp) {
    case 1:
        *p = color;
        break;
    case 2:
        *(Uint16 *)p = color;
        break;
    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
            p[0] = (color >> 16) & 0xff;
            p[1] = (color >> 8) & 0xff;
            p[2] = color & 0xff;
        } else {
            p[0] = color & 0xff;
            p[1] = (color >> 8) & 0xff;
            p[2] = (color >> 16) & 0xff;
        }
        break;
    case 4:
        *(Uint32 *)p = color;
        break;
    } /* switch */
    

  }
  
  return(0);
}

Uint32 getpixel(SDL_Surface *surface, int x, int y){
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to retrieve */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        return *p;

    case 2:
        return *(Uint16 *)p;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
            return p[0] << 16 | p[1] << 8 | p[2];
        else
            return p[0] | p[1] << 8 | p[2] << 16;

    case 4:
        return *(Uint32 *)p;

    default:
        return 0;       /* shouldn't happen, but avoids warnings */
    }
}
void gp2x_set_volume(int leftVolume, int rightVolume)
{
    unsigned long soundDev = open("/dev/mixer", O_RDWR);
    if (soundDev)
    {
        int vol =(((leftVolume*0x50)/100)<<8)|((rightVolume*0x50)/100);
        ioctl(soundDev, SOUND_MIXER_WRITE_PCM, &vol);
        close(soundDev);
    }
}

void DrawPlayField(){
	//SDL_Rect maprect= {16,0,288,216};
	//SDL_SetClipRect(screen,&maprect);
	DrawImage( screen, background, -x, -y,255, NULL);
	DrawImage( screen, sky, -x*3 +scrollxoffset/8, -y*3+scrollyoffset/8,128, NULL);
	int xpos=-1;
	for (int xs=x-7;xs<x+8 ;xs++ ){
		int ypos=-1;
		for (int ys=y-5;ys<y+6 ;ys++ ){
			long offset=x+(y*121);
			char item=0;
			char thiswall=0;
			char nwall=0;
			char wwall=0;
			int type=0;
			if (xs>=0 && xs<=120 &&ys>=0 && ys<=85){
				offset=xs+(ys*121);
				thiswall=buffer[offset] & 3;
				if (ys!=0) nwall=buffer[offset-121] & 2;
				wwall=buffer[offset-1] & 1;
				item=(buffer[offset]&240)/16;
			}
			if (thiswall==3 && nwall==2 && wwall==1) type=9; //t_int
			if (thiswall==3 && nwall==0 && wwall==1) type=6; //s_int
			if (thiswall==3 && nwall==2 && wwall==0) type=7; //e_int
			if (thiswall==3 && nwall==0 && wwall==0) type=1; //nw

			if (thiswall==2 && nwall==2 && wwall==1) type=8; //w_int
			if (thiswall==2 && nwall==0 && wwall==1) type=2; //sw
			if (thiswall==2 && nwall==2 && wwall==0) type=15; //v_wall
			if (thiswall==2 && nwall==0 && wwall==0) type=10; //n_end

			if (thiswall==1 && nwall==2 && wwall==1) type=5; //n_int
			if (thiswall==1 && nwall==0 && wwall==1) type=14; //h_wall
			if (thiswall==1 && nwall==2 && wwall==0) type=3; //ne
			if (thiswall==1 && nwall==0 && wwall==0) type=13; //w_end
			
			if (thiswall==0 && nwall==2 && wwall==1) type=4; //se
			if (thiswall==0 && nwall==0 && wwall==1) type=12; //e_end
			if (thiswall==0 && nwall==2 && wwall==0) type=11; //s_end
			//fprintf (stderr,"offset=%ld this=%d north=%d west=%d type=%d\n",offset,thiswall, nwall, wwall, type);
			switch (type){
			case 1:
				DrawImage( screen, nw, scrollxoffset+xpos*24, scrollyoffset+ypos*24,255, NULL);
				break;
			case 2:
				DrawImage( screen, sw, scrollxoffset+xpos*24, scrollyoffset+ypos*24,255, NULL);
				break;
			case 3:
				DrawImage( screen, ne, scrollxoffset+xpos*24, scrollyoffset+ypos*24,255, NULL);
				break;
			case 4:
				DrawImage( screen, se, scrollxoffset+xpos*24, scrollyoffset+ypos*24,255, NULL);
				break;
			case 5:
				DrawImage( screen, n_int, scrollxoffset+xpos*24, scrollyoffset+ypos*24,255, NULL);
				break;
			case 6:
				DrawImage( screen, s_int, scrollxoffset+xpos*24, scrollyoffset+ypos*24,255, NULL);
				break;
			case 7:
				DrawImage( screen, e_int, scrollxoffset+xpos*24, scrollyoffset+ypos*24,255, NULL);
				break;
			case 8:
				DrawImage( screen, w_int, scrollxoffset+xpos*24, scrollyoffset+ypos*24,255, NULL);
				break;
			case 9:
				DrawImage( screen, t_int, scrollxoffset+xpos*24, scrollyoffset+ypos*24,255, NULL);
				break;
			case 10:
				DrawImage( screen, n_end, scrollxoffset+xpos*24, scrollyoffset+ypos*24,255, NULL);
				break;
			case 11:
				DrawImage( screen, s_end, scrollxoffset+xpos*24, scrollyoffset+ypos*24,255, NULL);
				break;
			case 12:
				DrawImage( screen, e_end, scrollxoffset+xpos*24, scrollyoffset+ypos*24,255, NULL);
				break;
			case 13:
				DrawImage( screen, w_end, scrollxoffset+xpos*24, scrollyoffset+ypos*24,255, NULL);
				break;
			case 14:
				DrawImage( screen, h_wall, scrollxoffset+xpos*24, scrollyoffset+ypos*24,255, NULL);
				break;
			case 15:
				DrawImage( screen, v_wall, scrollxoffset+xpos*24, scrollyoffset+ypos*24,255, NULL);
				break;
			}

			switch(item){
			case 1: //fuel
				DrawImage( screen, fuel, scrollxoffset+14+xpos*24, scrollyoffset+14+ypos*24,255, NULL);
				break;
			case 2: //tank
				DrawImage( screen, tank, scrollxoffset+14+xpos*24, scrollyoffset+14+ypos*24,255, NULL);
				break;
			case 3: //hyper
				DrawImage( screen, hyper, scrollxoffset+14+xpos*24, scrollyoffset+14+ypos*24,255, NULL);
				break;
			case 4: //destructo
				DrawImage( screen, destructo, scrollxoffset+14+xpos*24, scrollyoffset+14+ypos*24,255, NULL);
				break;
			case 5: //unknown
				DrawImage( screen, unknown, scrollxoffset+14+xpos*24, scrollyoffset+14+ypos*24,255, NULL);
				break;
			case 6: //point
				DrawImage( screen, point, scrollxoffset+14+xpos*24, scrollyoffset+14+ypos*24,255, NULL);
				break;
			case 7: //point
				DrawImage( screen, super, scrollxoffset+14+xpos*24, scrollyoffset+14+ypos*24,255, NULL);
				break;
			case 8: //point
				DrawImage( screen, map, scrollxoffset+14+xpos*24, scrollyoffset+14+ypos*24,255, NULL);
				break;
			}
			ypos++;
		}
		xpos++;
	}
	//SDL_SetClipRect(screen, NULL);
	DrawImage( screen, hud, 0,216,255, NULL);
	DrawImage( screen, hudside, 0, 0,255, NULL);
	DrawImage( screen, hudside, 304, 0,255, NULL);
	DrawImage( screen, fuelpointer,104+(fuellevel+fuellevel) , 223,255, NULL);
	for (int i=1;i<=(extratanks>6?6:extratanks);i++ ){
		DrawImage( screen, lifemarker,9+i*13, 216,255, NULL);
	}
	int dit = score;
	for (int i=1;i<=5 ;i++){
		int digit = dit % 10;
		if ((i==4) && (digit!=thousands)){
			freefuel=true;
			thousands=digit;
		}
		digitoffset=(SDL_Rect) {digit*14,0,14,27};
		DrawImage( screen, numbers, 296-(14*i), 216,255, &digitoffset);
		dit = dit /10;
	}
}

void DrawPlayer(){
	switch (facing){
	case 0:
		DrawImage( screen, playern, 12+6*24, 11+4*24,255, NULL);
		break;
	case 1:
		DrawImage( screen, playere, 14+6*24, 12+4*24,255, NULL);
		break;
	case 2:
		DrawImage( screen, players, 13+6*24, 13+4*24,255, NULL);
		break;
	case 3:
		DrawImage( screen, playerw, 11+6*24, 11+4*24,255, NULL);
		break;
	}
}

void DrawEnemy(){
	SDL_Rect maprect= {16,0,288,216};
	SDL_SetClipRect(screen,&maprect);
	//int dx=ex-x;
	//int dy=ey-y;
	//fprintf(stderr,"Drawing enemy at: %d,%d | %d,%d\n",ex,ey,dx,dy);
	//DrawImage( screen, destructo, 12+((6+dx)*24), 12+((4+dx)*24),255, NULL);
	switch (estate){
	case 0:
		boxRGBA(screen, scrollxoffset+ exoffset+12+((6+ex-x)*24), scrollyoffset+eyoffset+12+((4+ey-y)*24), scrollxoffset+exoffset+(36+(6+ex-x)*24),scrollyoffset+eyoffset+(36+(4+ey-y)*24), 255, 0, 0, 255);
		//DrawImage( screen, destructo, exoffset+12+((6+ex-x)*24), eyoffset+12+((4+ey-y)*24),255, NULL);
		break;
	case 1:
		boxRGBA(screen, scrollxoffset+exoffset+16+((6+ex-x)*24), scrollyoffset+eyoffset+16+((4+ey-y)*24), scrollxoffset+exoffset+(32+(6+ex-x)*24),scrollyoffset+eyoffset+(32+(4+ey-y)*24), 255, 0, 0, 255);
		//DrawImage( screen, destructo, exoffset+12+((6+ex-x)*24), eyoffset+12+((4+ey-y)*24),255, NULL);
		break;
	case 2:
		boxRGBA(screen, scrollxoffset+exoffset+20+((6+ex-x)*24), scrollyoffset+eyoffset+20+((4+ey-y)*24), scrollxoffset+exoffset+(28+(6+ex-x)*24),scrollyoffset+eyoffset+(28+(4+ey-y)*24), 255, 0, 0, 255);
		//DrawImage( screen, destructo, exoffset+12+((6+ex-x)*24), eyoffset+12+((4+ey-y)*24),255, NULL);
		break;
	case 3:
		boxRGBA(screen, scrollxoffset+exoffset+24+((6+ex-x)*24), scrollyoffset+eyoffset+24+((4+ey-y)*24), scrollxoffset+exoffset+(24+(6+ex-x)*24),scrollyoffset+eyoffset+(24+(4+ey-y)*24), 255, 0, 0, 255);
		//DrawImage( screen, destructo, exoffset+12+((6+ex-x)*24), eyoffset+12+((4+ey-y)*24),255, NULL);
		break;
	}
	SDL_SetClipRect(screen,NULL);
}

void GameInitialize(){
	long lSize;
	long result;

	FILE * pFile;

	pFile = fopen ( "map.dat" , "rb" );
	if (pFile==NULL) {fputs ("File error",stderr); exit (1);}

	// obtain file size:
	fseek (pFile , 0 , SEEK_END);
	lSize = ftell (pFile);
	rewind (pFile);

	// allocate memory to contain the whole file:
	buffer = (char*) malloc (sizeof(char)*lSize);
	if (buffer == NULL) {fputs ("Memory error",stderr); exit (2);}

	// copy the file into the buffer:
	result = fread (buffer,1,lSize,pFile);
	if (result != lSize) {fputs ("Reading error",stderr); exit (3);}

	/* the whole file is now loaded in the memory buffer. */

	// terminate
	fclose (pFile);

	warped=false;
	gamestart=true;
	idle=false;
	trymove=false;
	moving=false;
	freefuel=false;
	done=0;

	emoving=false;
	etrymove=false;
	exoffset=0;
	eyoffset=0;
	ex=0;
	ey=0;
	estate=0;

	score=0;
	thousands=0;
	enginesound=2;
	facing=0;
	wantsfacing=0;
	scrollxoffset=0;
	scrollyoffset=0;
	fuellevel=50;
	extratanks=2;
	x=59;
	y=42;
	superminecount=0;

	ethreattimer=0;
}

void DrawVolumeDisplay(){
	for (int i=0;i<=volume/5;i++){
		boxRGBA(screen, 10+(i*6),200, (i*6)+14,210, 255, 0, 0, 128);
	}
}

void progressbar(int x1,int y1,int x2,int y2,int r,int g,int b,int a,int max,int val){
	//fprintf(stderr,"progress: %f - %d\n",(float)val/(float)max,(int)((float)x2*(float)((float)val/(float)max)));
	boxRGBA(screen, x1,y1,(int)((float)x2*(float)((float)val/(float)max)),y2,r,g,b,a);
}

void confirm_exit(){
	bool confirm_done=0;
	SDL_Surface *dialog;
	SDL_Surface *temp;
	temp = IMG_Load("./img/exit_dialog.png");
	dialog=SDL_DisplayFormatAlpha(temp);
	temp = SDL_DisplayFormatAlpha(screen);
	tunnelize (temp,5);
	DrawImage(screen,temp,0,0,255,NULL);
	DrawImage(screen,dialog,160-dialog->w/2,120-dialog->h/2,255,NULL);
	SDL_Flip(screen);
	flushevents();
	while(!confirm_done){
		//user_input();
		SDL_Event event;

		/* Check for events */
		//if (!slidecycle && !scrollcycle){
		while (SDL_PollEvent (&event)){
			switch (event.type){
				case SDL_KEYDOWN:
                case SDL_JOYBUTTONDOWN:
					
					/* Right now I have Start end the program for debug purposes */
					if (( (event.key.keysym.sym == SDLK_c) && (event.key.keysym.mod & (KMOD_LCTRL | KMOD_RCTRL)))) {
						confirm_done =1; done = 1;
					}
					if (( event.key.keysym.sym == SDLK_s )||( event.jbutton.button == VK_FA )) {
                    }     
					if (( event.key.keysym.sym == SDLK_d )||( event.jbutton.button == VK_FY )) {
						hypermine(screen,0);
						confirm_done =1; done = 1;
					}
					if (( event.key.keysym.sym == SDLK_c )||( event.jbutton.button == VK_FB )) {
						confirm_done=1;
                    }     
					if (( event.key.keysym.sym == SDLK_x )||( event.jbutton.button == VK_FX )) {
					}
					if (( event.key.keysym.sym == SDLK_RIGHT )||( event.jbutton.button == VK_RIGHT )) {
					}     
					if (( event.key.keysym.sym == SDLK_LEFT )||( event.jbutton.button == VK_LEFT )) {
					}     
					if (( event.key.keysym.sym == SDLK_UP )||( event.jbutton.button == VK_UP )) {
                    }     
                    if (( event.key.keysym.sym == SDLK_DOWN )||( event.jbutton.button == VK_DOWN )) {
					}
                    if (( event.key.keysym.sym == SDLK_f )||( event.jbutton.button == VK_FR )) {
						screenshot();
					}
                    if (( event.key.keysym.sym == SDLK_a )||( event.jbutton.button == VK_FL )) {
					}
                    if (( event.key.keysym.sym == SDLK_BACKSPACE )||( event.jbutton.button == VK_SELECT )) {
					}
                    if (( event.key.keysym.sym == SDLK_BACKSPACE )||( event.jbutton.button == VK_START )) {
					}
                    if (( event.key.keysym.sym == SDLK_BACKSPACE )||( event.jbutton.button == VK_VOL_UP )) {
					}
                    if (( event.key.keysym.sym == SDLK_BACKSPACE )||( event.jbutton.button == VK_VOL_DOWN )) {
					}
                    if (( event.key.keysym.sym == SDLK_HOME )||( event.jbutton.button == VK_TAT )) {
					}
					//buttonpressed=true;
					//buttontimer=SDL_GetTicks();
					break;
				case SDL_KEYUP:
				case SDL_JOYBUTTONUP:     
					if (( event.key.keysym.sym == SDLK_x )||( event.jbutton.button == VK_FX )) {
					}
					if (( event.key.keysym.sym == SDLK_RIGHT )||( event.jbutton.button == VK_RIGHT )) {
					}     
					if (( event.key.keysym.sym == SDLK_LEFT )||( event.jbutton.button == VK_LEFT )) {
					}     
					if (( event.key.keysym.sym == SDLK_UP )||( event.jbutton.button == VK_UP )) {
                    }     
                    if (( event.key.keysym.sym == SDLK_DOWN )||( event.jbutton.button == VK_DOWN )) {
					}

				//buttonpressed=false;					
					//buttontimerresolution=500;
				    break;
				case SDL_QUIT:
					confirm_done=1; done = 1;
					break;
				default:
					//buttonpressed=false;					
					//buttontimerresolution=500;
					break;
			}
		}
	}
	flushevents();
	SDL_FreeSurface(dialog);
	SDL_FreeSurface(temp);
}

void youwin(){
	SDL_Surface *temp1;
	SDL_Surface *temp2;
	SDL_Surface *temp3;
	SDL_Surface *temp4;
	SDL_Surface *temp5;
	temp1 = SDL_DisplayFormatAlpha(screen);
	tunnelize (temp1,-5);
	temp2 = SDL_DisplayFormatAlpha(temp1);
	tunnelize (temp2,-5);
	temp3 = SDL_DisplayFormatAlpha(temp2);
	tunnelize (temp3,-5);
	temp4 = SDL_DisplayFormatAlpha(temp3);
	tunnelize (temp4,-5);
	temp5 = SDL_DisplayFormatAlpha(temp4);
	tunnelize (temp5,-5);

	Mix_FadeOutChannel(2,25);
	Mix_PlayChannel(1, warpout, 0);
	
	DrawImage(screen,temp1,0,0,255,NULL);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
	
	DrawImage(screen,temp2,0,0,255,NULL);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
	
	DrawImage(screen,temp3,0,0,255,NULL);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
	
	DrawImage(screen,temp4,0,0,255,NULL);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);
	
	DrawImage(screen,temp5,0,0,255,NULL);
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	score=score+20000;
	DrawImage(screen,youwinimg,0,0,255,NULL);
	int dit = score;
	for (int i=1;i<=5 ;i++){
		int digit = dit % 10;
		digitoffset=(SDL_Rect) {digit*14,0,14,27};
		DrawImage( screen, numbers, 75-(14*i), 45,255, &digitoffset);
		dit = dit /10;
	}
	SDL_Flip(screen);
	SDL_framerateDelay(&manager);

	waitforpress();
	GameInitialize();
	SDL_FreeSurface(temp1);
	SDL_FreeSurface(temp2);
	SDL_FreeSurface(temp3);
	SDL_FreeSurface(temp4);
	SDL_FreeSurface(temp5);
}

void waitforpress(){
	int done=0;
	flushevents();
	while (!done){
	SDL_Event event;

	/* Check for events */
	//if (!slidecycle && !scrollcycle){
	while (SDL_PollEvent (&event)){
		switch (event.type){
			case SDL_KEYDOWN:
	        case SDL_JOYBUTTONDOWN:
                if (( event.key.keysym.sym == SDLK_HOME )||( event.jbutton.button == VK_FR )) {
					screenshot();
				}

				done=1;
			}
		}
	}
	flushevents();
}

void screenshot(){
//	SDL_SaveBMP(screen,"/mnt/sd/screenshot.bmp");
//	fprintf(stderr,"ScreenShot!\n");
//	sync();
}
